
# widget hierarchy

toplevel .configdialog -background darkblue

listbox .configdialog.selectscript -background white -selectmode single

frame .configdialog.buttonframe -background SlateBlue

button .configdialog.buttonframe.configcreatebutton -text "Create Script" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90 -command "ConfigureScriptCommand CREATE"
 
button .configdialog.buttonframe.configscriptbutton -text "Configure Script" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90 -command "ConfigureScriptCommand MODIFY"

button .configdialog.buttonframe.configdeletebutton -text "Delete Script" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90 -command ConfigureDelete

button .configdialog.buttonframe.configclosebutton -text "Close" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90 -command CloseDialog

# pack widgets

wm title .configdialog "Script list"

pack .configdialog.selectscript -side left -fill both -expand 1

bind .configdialog.selectscript <Double-Button-1> {
    LoadConfigure [selection get]
}

pack .configdialog.buttonframe -side top -fill both -expand 1

pack .configdialog.buttonframe.configcreatebutton -side top -fill x -padx 2 -pady 2

pack .configdialog.buttonframe.configscriptbutton -side top -fill x -padx 2 -pady 2

pack .configdialog.buttonframe.configdeletebutton -side top -fill x -padx 2 -pady 2 

pack .configdialog.buttonframe.configclosebutton -side bottom -fill x  -padx 2 -pady 2 

# procedures

proc CloseDialog {} {
    global .configdialog

    destroy .configdialog
}

proc PutScriptFileList FileList  {
    global .configdialog.selectscript

    .configdialog.selectscript delete 0 [.configdialog.selectscript size]

    foreach i $FileList {
	.configdialog.selectscript insert end $i
    }
}

# configure script procedures 

proc ConfigureDelete {} {
    global .configdialog.selectscript

    set selectlist [.configdialog.selectscript curselection]
    if { $selectlist == {} } {
	tk_dialog .dialog "Warning !" "Please select a script first" warning 0 Ok
	return
    } else {
	set fname [.configdialog.selectscript get $selectlist]
	exec rm -f  $fname
	RefreshSelectBox
	DefaultSelectedScript
    }
}

proc ConfigureScriptCommand command {
    global .configdialog.selectscript
    global .scriptdialog
    global SelectedScript

    if { $command=="MODIFY" } {
	set selectlist [.configdialog.selectscript curselection]
	if { $selectlist == {} } {
	    tk_dialog .dialog "Warning !" "Please select a script first" warning 0 Ok
	    return
	} else {
	    set fname [.configdialog.selectscript get $selectlist]
	    LoadConfigure $fname
	}
	
    } else {
	DefaultSelectedScript
    }
	
    toplevel .scriptdialog

    # server frame

    frame .scriptdialog.serverframe -background blue
    label .scriptdialog.serverframe.serverlabel -text "Server" -background blue -relief raised
    label .scriptdialog.serverframe.namelabel -text "Name" -background blue -relief groove
    entry .scriptdialog.serverframe.nameentry -textvariable SelectedScript(name) -background lightblue
    label .scriptdialog.serverframe.phonelabel -text "Phone" -background blue -relief groove
    entry .scriptdialog.serverframe.phoneentry -textvariable SelectedScript(phone) -background lightblue
    label .scriptdialog.serverframe.ipsourcelabel -text "Ip Source" -background blue -relief groove
    entry .scriptdialog.serverframe.ipsourceentry -textvariable SelectedScript(ipsource) -background lightblue

    label .scriptdialog.serverframe.ipdestlabel -text "Ip Dest" -background blue -relief groove
    entry .scriptdialog.serverframe.ipdestentry -textvariable SelectedScript(ipdest) -background lightblue

    #user frame

    frame .scriptdialog.userframe -background mediumblue
    label .scriptdialog.userframe.userlabel -text "User" -background mediumblue -foreground white -relief raised 
    label .scriptdialog.userframe.loginlabel -text "Login" -background mediumblue -foreground white -relief groove
    entry .scriptdialog.userframe.loginentry -textvariable SelectedScript(login) -background lightblue
    label .scriptdialog.userframe.passwordlabel -text "Password" -background mediumblue -foreground white -relief groove
    entry .scriptdialog.userframe.passwordentry -textvariable SelectedScript(password)  -background lightblue

    button .scriptdialog.userframe.okbutton -text "Ok" -command ConfigureOk
    button .scriptdialog.userframe.defaultbutton -text "Default" -command DefaultSelectedScript
    button .scriptdialog.userframe.cancelbutton -text "Cancel" -command ConfigureCancel

    #option frame

    frame .scriptdialog.optionframe -background darkblue
    label .scriptdialog.optionframe.optionlabel -text options -background darkblue -foreground white -relief raised
    label .scriptdialog.optionframe.modemdevlabel -text "Modem device" -background darkblue -foreground white -relief groove
    entry .scriptdialog.optionframe.modemdeventry -textvariable SelectedScript(modemdev) -background lightblue
    label .scriptdialog.optionframe.modemspeedlabel -text "Modem speed" -background darkblue -foreground white -relief groove
    entry .scriptdialog.optionframe.modemspeedentry -textvariable SelectedScript(modemspeed) -background lightblue

    checkbutton .scriptdialog.optionframe.debugbutton -variable SelectedScript(debug) -text "debug" -onvalue "debug" -offvalue "" -background blue
    checkbutton .scriptdialog.optionframe.noipdefaultbutton -variable SelectedScript(noipdefault) -text "No ip default" -onvalue "noipdefault" -offvalue "" -background blue
    checkbutton .scriptdialog.optionframe.crtsctsbutton -variable SelectedScript(crtscts) -text "Crtscts" -onvalue "crtscts" -offvalue "" -background blue

    #packing

    pack .scriptdialog.serverframe -side left -ipadx 4 -ipady 4 -fill both

    pack .scriptdialog.serverframe.serverlabel -side top
    pack .scriptdialog.serverframe.namelabel -side top -anchor w
   pack .scriptdialog.serverframe.nameentry -after .scriptdialog.serverframe.namelabel -side top

    pack .scriptdialog.serverframe.phonelabel -side top -anchor w
    pack .scriptdialog.serverframe.phoneentry -side top

    pack .scriptdialog.serverframe.ipsourcelabel -side top -anchor w
    pack .scriptdialog.serverframe.ipsourceentry -side top

    pack .scriptdialog.serverframe.ipdestlabel -side top -anchor w
    pack .scriptdialog.serverframe.ipdestentry -side top

    #user frame

    pack .scriptdialog.userframe -side left -ipadx 4 -ipady 4 -fill both
    pack .scriptdialog.userframe.userlabel -side top
    pack .scriptdialog.userframe.loginlabel -side top -anchor w
    pack .scriptdialog.userframe.loginentry -side top -anchor w -padx 4
    pack .scriptdialog.userframe.passwordlabel -side top -anchor w
    pack .scriptdialog.userframe.passwordentry -side top -anchor w -padx 4
    
    pack .scriptdialog.userframe.okbutton -side left -padx 8
    pack .scriptdialog.userframe.defaultbutton -side left -padx 4
    pack .scriptdialog.userframe.cancelbutton -side left -padx 4

    #option frame

    pack .scriptdialog.optionframe -side top -ipadx 4 -ipady 4 -fill both -expand 1
    pack .scriptdialog.optionframe.optionlabel -side top
    pack .scriptdialog.optionframe.modemdevlabel -side top -ancho w
    pack .scriptdialog.optionframe.modemdeventry -side top
    pack .scriptdialog.optionframe.modemspeedlabel -side top -ancho w
    pack .scriptdialog.optionframe.modemspeedentry -side top
    pack .scriptdialog.optionframe.debugbutton -side top -anchor w -padx 8 -pady 8
    pack .scriptdialog.optionframe.noipdefaultbutton -side top -anchor w -padx 8 -pady 8
    pack .scriptdialog.optionframe.crtsctsbutton -side top -ancho w -padx 8 -pady 8

    wm resizable .scriptdialog 0 0
    wm title .scriptdialog "configure script"
    grab .scriptdialog
}

proc ConfigureOk {} {
    global .scriptdialog

    destroy .scriptdialog
    SaveConfigure

    RefreshSelectBox
}

proc ConfigureCancel {} {
    global .scriptdialog

    destroy .scriptdialog
    DefaultSelectedScript
}

proc LoadConfigure { fname } {
    global SelectedScript

    set file [open $fname r]

    set line [gets $file]
    scan $line "name: %s" SelectedScript(name)

    set line [gets $file]
    scan $line "phone: %s" SelectedScript(phone)

    set line [gets $file]
    scan $line "ipsource: %s" SelectedScript(ipsource)

    set line [gets $file]
    scan $line "ipdest: %s" SelectedScript(ipdest)

    set line [gets $file]
    scan $line "login: %s" SelectedScript(login)

    set line [gets $file]
    scan $line "password: %s" SelectedScript(password)

    set line [gets $file]
    scan $line "modemdev: %s" SelectedScript(modemdev)

    set line [gets $file]
    scan $line "modemspeed: %s" SelectedScript(modemspeed)
    
    set line [gets $file]
    scan $line "debug: %s" SelectedScript(debug)

    set line [gets $file]
    scan $line "noipdefault: %s" SelectedScript(noipdefault)

    set line [gets $file]
    scan $line "crtscts: %s" SelectedScript(crtscts)

    close $file
}

proc SaveConfigure {} {
    global SelectedScript

    if { $SelectedScript(name) == "No Script" } {
	tk_dialog .dialog "Warning !" "Please create a valid script" warning 0 Ok
	return
    }

    set fname $SelectedScript(name)
    set fname "$fname.pppscript"
    set file [open $fname w]
    puts $file "name: $SelectedScript(name)"
    puts $file "phone: $SelectedScript(phone)"
    puts $file "ipsource: $SelectedScript(ipsource)"
    puts $file "ipdest: $SelectedScript(ipdest)"
    puts $file "login: $SelectedScript(login)"
    puts $file "password: $SelectedScript(password)"
    puts $file "modemdev: $SelectedScript(modemdev)"
    puts $file "modemspeed: $SelectedScript(modemspeed)"
    puts $file "debug: $SelectedScript(debug)"
    puts $file "noipdefault: $SelectedScript(noipdefault)"
    puts $file "crtscts: $SelectedScript(crtscts)"

    close $file
}

# main script

#global variables

proc RefreshSelectBox {} {

    set ScriptList [glob *.pppscript]

    PutScriptFileList $ScriptList
}

proc DefaultSelectedScript {} {
    global SelectedScript

    set SelectedScript(name) "No Script"
    set SelectedScript(phone) "---"
    set SelectedScript(login) "---"
    set SelectedScript(password) "---"
    set SelectedScript(noipdefault) "noipdefault"
    set SelectedScript(debug) "debug"
    set SelectedScript(ipsource) "0.0.0.0"
    set SelectedScript(ipdest) ""
    set SelectedScript(modemdev) "/dev/cua1"
    set SelectedScript(modemspeed) "9600"
    set SelectedScript(crtscts) "crtscts"
}

DefaultSelectedScript

RefreshSelectBox

grab .configdialog
tkwait window .configdialog

if { $SelectedScript(name) != "No Script" } {
    return [array get SelectedScript]
}

return {}

